# TNSI - tri par insertion - correction
# David TOCAVEN
# 25/11/2022
## importation des bibliothèques
from random import randint # pour les entiers aléatoires
from time import time # pour relever le temps
import matplotlib.pyplot as plt # pour afficher un graphique

## Déclaration de la fonction insere
def insere(tab,i_trie):
    """
    Fonction qui place la valeur d'indice i_trie
    au bon endroit pour que le tableau tab soit
    trier par ordre croissant entre les indices
    0 et i_trie.
    @param tab : (type:list) Le tableau a trier
    @param i_trie : (type:int) l'indice de la
                    valeur a ranger.
    """
    i_ins = i_trie
    tmp = tab[i_trie]
    while i_ins>0 and tmp< tab[i_ins - 1]:
        tab[i_ins] = tab[i_ins - 1]
        i_ins -= 1 # i_ins = i_ins - 1
    tab[i_ins] = tmp
## Déclaration de la fonction tri_insertion
def tri_insertion(tab):
    """
    Fonction qui trie un tableau d'entiers tab
    par ordre croissant.
    @param tab : (type:list) le tableau d'entiers
                 a trier.
    """
    for i_trie in range(1, len(tab)):
        insere(tab,i_trie)
## Déclaration de la fonction list_aleatoire
def list_aleatoire(nb_val):
    """
    Renvoie une liste de valeurs aléatoires
    comprisent entre -5000 et 5000.
    @ param nb_val : (type:int) nombre de valeurs dans le tableau.
                     Doit être supérieur à 0.
    """
    la_liste = []
    for i in range(nb_val):
        la_liste.append(randint(-5000, 5000))
    return la_liste
## tests
# # test de la fonction tri_insertion
#t = [3,2,9,-455]
#print(t)
#tri_insertion(t)
#print(t)
# # la fonction fonctionne correctement.

## Analyse des temps d'exécutions
l_nb_val = [10, 50, 100, 500, 1000, 2000, 3000, 4000, 5000]
# valeur par defaut : [10, 50, 100, 500, 1000, 5000]

durees = []
for nb_val in l_nb_val:
    t = list_aleatoire(nb_val) # création d'une liste de nb_val entiers aléatoires
    debut = time() # relever du temps avant le tri
    tri_insertion(t) # trie des valeurs
    fin = time() # relever du temps après le tri
    duree = fin-debut # calcul de la durée
    durees.append(duree) # ajout de la durée dans la liste durees
    print(f"{nb_val} valeurs : {duree} secondes")


## pour éviter de relancer les tries a chaque fois,
## décommenter les deux lignes en dessous et commenter
## la for précédente et ses instructions

#l_nb_val = [10, 50, 100, 500, 1000, 5000, 50000]
# durees = [0.0, 0.0, 0.0005240440368652344,  0.008475065231323242, 0.03799915313720703, 0.9570002555847168]#, 100.45354104042053]

plt.plot(l_nb_val, durees, "x-") # pour le graphique.
# Paramètres : (x, y, style)
# 'x-' : x pour faire une croix sur les points et - pour les relier par des segments
plt.title("Temps d'exécutions du tri par insertion")
plt.xlabel("Nombres de valeurs a trier") # titre des abscisses
plt.ylabel("Temps (s)") # titre des ordonnées
plt.show() # pour afficher le graphique